/*
 * Copyright 2014-2023 Real Logic Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef AERON_C_COUNTERS_H
#define AERON_C_COUNTERS_H

// Driver counters

#define AERON_COUNTER_SYSTEM_COUNTER_TYPE_ID (0)

#define AERON_COUNTER_PUBLISHER_LIMIT_NAME "pub-lmt"
#define AERON_COUNTER_PUBLISHER_LIMIT_TYPE_ID (1)

#define AERON_COUNTER_SENDER_POSITION_NAME "snd-pos"
#define AERON_COUNTER_SENDER_POSITION_TYPE_ID (2)

#define AERON_COUNTER_RECEIVER_HWM_NAME "rcv-hwm"
#define AERON_COUNTER_RECEIVER_HWM_TYPE_ID (3)

#define AERON_COUNTER_SUBSCRIPTION_POSITION_NAME "sub-pos"
#define AERON_COUNTER_SUBSCRIPTION_POSITION_TYPE_ID (4)

#define AERON_COUNTER_RECEIVER_POSITION_NAME "rcv-pos"
#define AERON_COUNTER_RECEIVER_POSITION_TYPE_ID (5)

#define AERON_COUNTER_SEND_CHANNEL_STATUS_NAME "snd-channel"
#define AERON_COUNTER_SEND_CHANNEL_STATUS_TYPE_ID (6)

#define AERON_COUNTER_RECEIVE_CHANNEL_STATUS_NAME "rcv-channel"
#define AERON_COUNTER_RECEIVE_CHANNEL_STATUS_TYPE_ID (7)

#define AERON_COUNTER_SENDER_LIMIT_NAME "snd-lmt"
#define AERON_COUNTER_SENDER_LIMIT_TYPE_ID (9)

#define AERON_COUNTER_PER_IMAGE_TYPE_ID (10)

#define AERON_COUNTER_CLIENT_HEARTBEAT_TIMESTAMP_NAME "client-heartbeat"
#define AERON_COUNTER_CLIENT_HEARTBEAT_TIMESTAMP_TYPE_ID (11)

#define AERON_COUNTER_PUBLISHER_POSITION_NAME "pub-pos (sampled)"
#define AERON_COUNTER_PUBLISHER_POSITION_TYPE_ID (12)

#define AERON_COUNTER_SENDER_BPE_NAME "snd-bpe"
#define AERON_COUNTER_SENDER_BPE_TYPE_ID  (13)

#define AERON_COUNTER_RCV_LOCAL_SOCKADDR_NAME "rcv-local-sockaddr"
#define AERON_COUNTER_SND_LOCAL_SOCKADDR_NAME "snd-local-sockaddr"
#define AERON_COUNTER_LOCAL_SOCKADDR_TYPE_ID (14)

// Name Resolver 15-16

#define AERON_COUNTER_FC_NUM_RECEIVERS_TYPE_ID (17)

#define AERON_COUNTER_CHANNEL_MDC_NUM_DESTINATIONS_NAME "mdc-num-dest"
#define AERON_COUNTER_CHANNEL_NUM_DESTINATIONS_TYPE_ID (18)

// AERON_EF_VI reserved range 50-74
// AERON_DPDK reserved range 75-99

// Archive counters

#define AERON_COUNTER_ARCHIVE_RECORDING_POSITION_TYPE_ID (100);

#define AERON_COUNTER_ARCHIVE_ERROR_COUNT_TYPE_ID (101);

#define AERON_COUNTER_ARCHIVE_CONTROL_SESSIONS_TYPE_ID (102);

#define AERON_COUNTER_ARCHIVE_MAX_CYCLE_TIME_TYPE_ID (103);

#define AERON_COUNTER_ARCHIVE_CYCLE_TIME_THRESHOLD_EXCEEDED_TYPE_ID (104);

#define AERON_COUNTER_ARCHIVE_RECORDER_MAX_WRITE_TIME_TYPE_ID (105);

#define AERON_COUNTER_ARCHIVE_RECORDER_TOTAL_WRITE_BYTES_TYPE_ID (106);

#define AERON_COUNTER_ARCHIVE_RECORDER_TOTAL_WRITE_TIME_TYPE_ID (107);

#define AERON_COUNTER_ARCHIVE_REPLAYER_MAX_READ_TIME_TYPE_ID (108);

#define AERON_COUNTER_ARCHIVE_REPLAYER_TOTAL_READ_BYTES_TYPE_ID (109);

#define AERON_COUNTER_ARCHIVE_REPLAYER_TOTAL_READ_TIME_TYPE_ID (110);

// Cluster counters

#define AERON_COUNTER_CLUSTER_CONSENSUS_MODULE_STATE_TYPE_ID (200)

#define AERON_COUNTER_CLUSTER_NODE_ROLE_TYPE_ID (201)

#define AERON_COUNTER_CLUSTER_CONTROL_TOGGLE_TYPE_ID (202)

#define AERON_COUNTER_CLUSTER_COMMIT_POSITION_TYPE_ID (203)

#define AERON_COUNTER_CLUSTER_RECOVERY_STATE_TYPE_ID (204)

#define AERON_COUNTER_CLUSTER_SNAPSHOT_COUNTER_TYPE_ID (205)

#define AERON_COUNTER_CLUSTER_ELECTION_STATE_TYPE_ID (207)

#define AERON_COUNTER_CLUSTER_BACKUP_STATE_TYPE_ID (208)

#define AERON_COUNTER_CLUSTER_BACKUP_LIVE_LOG_POSITION_TYPE_ID (209)

#define AERON_COUNTER_CLUSTER_BACKUP_QUERY_DEADLINE_TYPE_ID (210)

#define AERON_COUNTER_CLUSTER_BACKUP_ERROR_COUNT_TYPE_ID (211)

#define AERON_COUNTER_CLUSTER_CONSENSUS_MODULE_ERROR_COUNT_TYPE_ID (212)

#define AERON_COUNTER_CLUSTER_CLIENT_TIMEOUT_COUNT_TYPE_ID (213)

#define AERON_COUNTER_CLUSTER_INVALID_REQUEST_COUNT_TYPE_ID (214)

#define AERON_COUNTER_CLUSTER_CLUSTERED_SERVICE_ERROR_COUNT_TYPE_ID (215)

#define AERON_COUNTER_CLUSTER_MAX_CYCLE_TIME_TYPE_ID (216)

#define AERON_COUNTER_CLUSTER_CYCLE_TIME_THRESHOLD_EXCEEDED_TYPE_ID (217)

#define AERON_COUNTER_CLUSTER_CLUSTERED_SERVICE_MAX_CYCLE_TIME_TYPE_ID (218)

#define AERON_COUNTER_CLUSTER_CLUSTERED_SERVICE_CYCLE_TIME_THRESHOLD_EXCEEDED_TYPE_ID (219)

#define AERON_COUNTER_CLUSTER_STANDBY_STATE_TYPE_ID (220)

#define AERON_COUNTER_CLUSTER_STANDBY_ERROR_COUNT_TYPE_ID (221)

#define AERON_COUNTER_CLUSTER_STANDBY_HEARTBEAT_RESPONSE_COUNT_TYPE_ID (222)

#define AERON_COUNTER_CLUSTER_STANDBY_CONTROL_TOGGLE_TYPE_ID (223)

#define AERON_COUNTER_CLUSTER_TRANSITION_MODULE_STATE_TYPE_ID (224)

#define AERON_COUNTER_CLUSTER_TRANSITION_MODULE_CONTROL_TOGGLE_TYPE_ID (225)

#define AERON_COUNTER_CLUSTER_TRANSITION_MODULE_ERROR_COUNT_TYPE_ID (226)

#define AERON_COUNTER_CLUSTER_STANDBY_MAX_CYCLE_TIME_TYPE_ID (227)

#define AERON_COUNTER_CLUSTER_STANDBY_CYCLE_TIME_THRESHOLD_EXCEEDED_TYPE_ID (228)

#define AERON_COUNTER_CLUSTER_TRANSITION_MODULE_MAX_CYCLE_TIME_TYPE_ID (229)

#define AERON_COUNTER_CLUSTER_TRANSITION_MODULE_CYCLE_TIME_THRESHOLD_EXCEEDED_TYPE_ID (230)

#define AERON_COUNTER_CLUSTER_STANDBY_SOURCE_MEMBER_ID_TYPE_ID (231)

#endif //AERON_C_COUNTERS_H
